import { useEffect, useState } from 'react';
import useSDKFactory from './useSDKFactory';
import { PassListenable, UseCase, SRListenable, } from '@inkerlabs/sdk';
export default function useContractMetadatadataFactory(useCase) {
    return function useContractMetadata() {
        var sdk = useSDKFactory()();
        var _a = useState(undefined), metadata = _a[0], setMetadata = _a[1];
        var _b = useState(undefined), error = _b[0], setError = _b[1];
        var id;
        var cb = function (err, _metadata) {
            setError(err);
            setMetadata(_metadata);
        };
        var unlisten = function () {
            switch (useCase) {
                case UseCase.PASS:
                    var passSDK = sdk;
                    if (id) {
                        passSDK.unlisten(id, PassListenable.CONTRACT_METADATA);
                    }
                    break;
                case UseCase.SR:
                    var srSDK = sdk;
                    if (id) {
                        srSDK.unlisten(id, SRListenable.CONTRACT_METADATA);
                    }
                    break;
                default:
                    throw new Error("Unspported use case ".concat(useCase));
            }
        };
        useEffect(function () {
            unlisten();
            switch (useCase) {
                case UseCase.PASS:
                    var passSDK = sdk;
                    passSDK.listen(PassListenable.CONTRACT_METADATA, cb);
                    break;
                case UseCase.SR:
                    var srSDK = sdk;
                    srSDK.listen(SRListenable.CONTRACT_METADATA, cb);
                    break;
                default:
                    throw new Error("Unspported use case ".concat(useCase));
            }
        }, []);
        // Emulate componentWillUnmount
        useEffect(function () {
            return function () {
                unlisten();
            };
        }, []);
        return [metadata, error];
    };
}
